// ezManagerLib_ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ezManagerLib_Example.h"
#include "ezManagerLib_ExampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzManagerLib_ExampleDlg dialog

CEzManagerLib_ExampleDlg::CEzManagerLib_ExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEzManagerLib_ExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEzManagerLib_ExampleDlg)
	m_local_remote = 0;
	m_product = _T("");
	m_status = _T("");
	m_baud_rate1 = _T("");
	m_baud_rate2 = _T("");
	m_baud_rate3 = _T("");
	m_baud_rate4 = _T("");
	m_peer1		 = _T("");
	m_peer2		 = _T("");
	m_peer3		 = _T("");
	m_peer4		 = _T("");
	m_macro = FALSE;
	m_modbus = FALSE;
	m_http = FALSE;
	m_script_0 = _T("");
	m_cur_pwd = _T("");
	m_new_pwd = _T("");
	m_di_str0 = _T("");
	m_di_str1 = _T("");
	m_di_str2 = _T("");
	m_di_str3 = _T("");
	m_di_str4 = _T("");
	m_di_str5 = _T("");
	m_di_str6 = _T("");
	m_di_str7 = _T("");
	m_do_str0 = _T("");
	m_do_str1 = _T("");
	m_do_str2 = _T("");
	m_do_str3 = _T("");
	m_do_str4 = _T("");
	m_do_str5 = _T("");
	m_do_str6 = _T("");
	m_do_str7 = _T("");
	m_ddns_hostname = _T("");
	m_ddns_id = _T("");
	m_ddns_pwd = _T("");
	m_fw_version = _T("");
	m_ea0 = _T("00");
	m_ea1 = _T("30");
	m_ea2 = _T("f9");
	m_ea3 = _T("00");
	m_ea4 = _T("00");
	m_ea5 = _T("01");
	m_eztcp_addr = _T("");
	m_local_ip_addr = _T("");
	m_subnet_ip4 = _T("");
	m_ddns_port_str = _T("");
	m_ddns_interval_str = _T("");
	m_unit_id = _T("");
	m_input_address = _T("");
	m_output_address = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//this->lib_env_base = (struct lib_env*)malloc(sizeof(struct lib_env)*256);

	p_baud[0] = &m_baud_rate1;
	p_baud[1] = &m_baud_rate2;
	p_baud[2] = &m_baud_rate3;
	p_baud[3] = &m_baud_rate4;

	p_baud_ctrl[0] = &m_baud_ctrl1;
	p_baud_ctrl[1] = &m_baud_ctrl2;
	p_baud_ctrl[2] = &m_baud_ctrl3;
	p_baud_ctrl[3] = &m_baud_ctrl4;

	p_mux_ctrl[0] = &m_mux1;
	p_mux_ctrl[1] = &m_mux2;
	p_mux_ctrl[2] = &m_mux3;
	p_mux_ctrl[3] = &m_mux4;

	p_peer[0] = &m_peer1;
	p_peer[1] = &m_peer2;
	p_peer[2] = &m_peer3;
	p_peer[3] = &m_peer4;

	p_peer_ctrl[0] = &m_peer_ctrl1;
	p_peer_ctrl[1] = &m_peer_ctrl2;
	p_peer_ctrl[2] = &m_peer_ctrl3;
	p_peer_ctrl[3] = &m_peer_ctrl4;

	Start_Library();
}
CEzManagerLib_ExampleDlg::~CEzManagerLib_ExampleDlg()
{
	End_Library();
}

void CEzManagerLib_ExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEzManagerLib_ExampleDlg)
	DDX_Control(pDX, IDC_EDIT_SLAVE_ID, m_slave_id_ctrl);
	DDX_Control(pDX, IDC_COMBO_TCP_CONNECTION, m_tcp_connection);
	DDX_Control(pDX, IDC_COMBO_DDNS_STYLE, m_combo_style_ctrl);
	DDX_Control(pDX, IDC_COMBO_DDNS, m_combo_ddns_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_0, m_script_0_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_1, m_script_1_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_2, m_script_2_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_3, m_script_3_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_4, m_script_4_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_5, m_script_5_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_6, m_script_6_ctrl);
	DDX_Control(pDX, IDC_EDIT_SCRIPT_7, m_script_7_ctrl);
	DDX_Control(pDX, IDC_EDIT_OUTPUT_ADDR, m_output_addr_ctrl);
	DDX_Control(pDX, IDC_EDIT_INPUT_ADDR, m_input_addr_ctrl);
	DDX_Control(pDX, IDC_CHECK_MODBUS, m_modbus_ctrl);
	DDX_Control(pDX, IDC_CHECK_MACRO, m_macro_ctrl);
	DDX_Control(pDX, IDC_CHECK_HTTP, m_http_ctrl);	
	DDX_Control(pDX, IDC_EDIT_PEER, m_peer_ctrl1);
	DDX_Control(pDX, IDC_EDIT_PEER2, m_peer_ctrl2);
	DDX_Control(pDX, IDC_EDIT_PEER3, m_peer_ctrl3);
	DDX_Control(pDX, IDC_EDIT_PEER4, m_peer_ctrl4);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE, m_baud_ctrl1);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE2, m_baud_ctrl2);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE3, m_baud_ctrl3);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE4, m_baud_ctrl4);
	DDX_Control(pDX, IDC_COMBO_MUX, m_mux1);
	DDX_Control(pDX, IDC_COMBO_MUX2, m_mux2);
	DDX_Control(pDX, IDC_COMBO_MUX3, m_mux3);
	DDX_Control(pDX, IDC_COMBO_MUX4, m_mux4);
	DDX_Control(pDX, IDC_EDIT_STATUS, m_status_ctrl);
	DDX_Control(pDX, IDC_LIST_EZTCP, m_list_eztcp);
	DDX_Radio(pDX, IDC_RADIO_LOCAL, m_local_remote);
	DDX_Text(pDX, IDC_EDIT_PRODUCT, m_product);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_status);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE, m_baud_rate1);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE2, m_baud_rate2);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE3, m_baud_rate3);
	DDX_Text(pDX, IDC_EDIT_BAUDRATE4, m_baud_rate4);
	DDX_Text(pDX, IDC_EDIT_PEER, m_peer1);
	DDX_Text(pDX, IDC_EDIT_PEER2, m_peer2);
	DDX_Text(pDX, IDC_EDIT_PEER3, m_peer3);
	DDX_Text(pDX, IDC_EDIT_PEER4, m_peer4);
	DDX_Check(pDX, IDC_CHECK_MACRO, m_macro);
	DDX_Check(pDX, IDC_CHECK_MODBUS, m_modbus);
	DDX_Check(pDX, IDC_CHECK_HTTP, m_http);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_0, m_script_0);
	DDV_MaxChars(pDX, m_script_0, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_1, m_script_1);
	DDV_MaxChars(pDX, m_script_1, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_2, m_script_2);
	DDV_MaxChars(pDX, m_script_2, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_3, m_script_3);
	DDV_MaxChars(pDX, m_script_3, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_4, m_script_4);
	DDV_MaxChars(pDX, m_script_4, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_5, m_script_5);
	DDV_MaxChars(pDX, m_script_5, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_6, m_script_6);
	DDV_MaxChars(pDX, m_script_6, 32);
	DDX_Text(pDX, IDC_EDIT_SCRIPT_7, m_script_7);
	DDV_MaxChars(pDX, m_script_7, 32);
	DDX_Text(pDX, IDC_EDIT_CUR_PWD, m_cur_pwd);
	DDV_MaxChars(pDX, m_cur_pwd, 8);
	DDX_Text(pDX, IDC_EDIT_NEW_PWD, m_new_pwd);
	DDV_MaxChars(pDX, m_new_pwd, 8);
	DDX_Control(pDX, IDC_EDIT_DI_STR0, m_di_str0_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR1, m_di_str1_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR2, m_di_str2_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR3, m_di_str3_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR4, m_di_str4_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR5, m_di_str5_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR6, m_di_str6_ctrl);
	DDX_Control(pDX, IDC_EDIT_DI_STR7, m_di_str7_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR0, m_do_str0_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR1, m_do_str1_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR2, m_do_str2_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR3, m_do_str3_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR4, m_do_str4_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR5, m_do_str5_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR6, m_do_str6_ctrl);
	DDX_Control(pDX, IDC_EDIT_DO_STR7, m_do_str7_ctrl);
	DDX_Text(pDX, IDC_EDIT_DI_STR0, m_di_str0);
	DDV_MaxChars(pDX, m_di_str0, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR1, m_di_str1);
	DDV_MaxChars(pDX, m_di_str1, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR2, m_di_str2);
	DDV_MaxChars(pDX, m_di_str2, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR3, m_di_str3);
	DDV_MaxChars(pDX, m_di_str3, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR4, m_di_str4);
	DDV_MaxChars(pDX, m_di_str4, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR5, m_di_str5);
	DDV_MaxChars(pDX, m_di_str5, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR6, m_di_str6);
	DDV_MaxChars(pDX, m_di_str6, 16);
	DDX_Text(pDX, IDC_EDIT_DI_STR7, m_di_str7);
	DDV_MaxChars(pDX, m_di_str7, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR0, m_do_str0);
	DDV_MaxChars(pDX, m_do_str0, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR1, m_do_str1);
	DDV_MaxChars(pDX, m_do_str1, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR2, m_do_str2);
	DDV_MaxChars(pDX, m_do_str2, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR3, m_do_str3);
	DDV_MaxChars(pDX, m_do_str3, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR4, m_do_str4);
	DDV_MaxChars(pDX, m_do_str4, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR5, m_do_str5);
	DDV_MaxChars(pDX, m_do_str5, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR6, m_do_str6);
	DDV_MaxChars(pDX, m_do_str6, 16);
	DDX_Text(pDX, IDC_EDIT_DO_STR7, m_do_str7);
	DDV_MaxChars(pDX, m_do_str7, 16);
	DDX_Text(pDX, IDC_EDIT_DDNS_HOSTNAME, m_ddns_hostname);
	DDV_MaxChars(pDX, m_ddns_hostname, 64);
	DDX_Text(pDX, IDC_EDIT_DDNS_ID, m_ddns_id);
	DDV_MaxChars(pDX, m_ddns_id, 32);
	DDX_Text(pDX, IDC_EDIT_DDNS_PWD, m_ddns_pwd);
	DDV_MaxChars(pDX, m_ddns_pwd, 16);
	DDX_Text(pDX, IDC_FW, m_fw_version);
	DDX_Text(pDX, IDC_EDIT_EA0, m_ea0);
	DDV_MaxChars(pDX, m_ea0, 2);
	DDX_Text(pDX, IDC_EDIT_EA1, m_ea1);
	DDV_MaxChars(pDX, m_ea1, 2);
	DDX_Text(pDX, IDC_EDIT_EA2, m_ea2);
	DDV_MaxChars(pDX, m_ea2, 2);
	DDX_Text(pDX, IDC_EDIT_EA3, m_ea3);
	DDV_MaxChars(pDX, m_ea3, 2);
	DDX_Text(pDX, IDC_EDIT_EA4, m_ea4);
	DDV_MaxChars(pDX, m_ea4, 2);
	DDX_Text(pDX, IDC_EDIT_EA5, m_ea5);
	DDV_MaxChars(pDX, m_ea5, 2);
	DDX_Text(pDX, IDC_EZTCP_ADDR, m_eztcp_addr);
	DDX_Text(pDX, IDC_LOCAL_ADDR, m_local_ip_addr);
	DDX_Text(pDX, IDC_SUBNET_IP4, m_subnet_ip4);
	DDX_Text(pDX, IDC_EDIT_DDNS_PORT_NUM, m_ddns_port_str);
	DDX_Text(pDX, IDC_EDIT_DDNS_INTERVAL, m_ddns_interval_str);
	DDX_Text(pDX, IDC_EDIT_SLAVE_ID, m_unit_id);
	DDX_Text(pDX, IDC_EDIT_INPUT_ADDR, m_input_address);
	DDX_Text(pDX, IDC_EDIT_OUTPUT_ADDR, m_output_address);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEzManagerLib_ExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CEzManagerLib_ExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEARCH, OnButtonSearch)
	ON_BN_CLICKED(IDC_RADIO_LOCAL, OnRadioLocal)
	ON_BN_CLICKED(IDC_RADIO_REMOTE, OnRadioRemote)
	ON_LBN_SELCHANGE(IDC_LIST_EZTCP, OnSelchangeListEztcp)
	ON_BN_CLICKED(IDC_BUTTON_STATUS, OnButtonStatus)
	ON_BN_CLICKED(IDC_BUTTON_WRITE, OnButtonWrite)
	ON_BN_CLICKED(IDC_BUTTON_CHANGE_PWD, OnButtonChangePwd)
	ON_BN_CLICKED(IDC_BUTTON_DELETE_PWD, OnButtonDeletePwd)
	ON_BN_CLICKED(IDC_BUTTON_PWD_SET, OnButtonPwdSet)
	ON_BN_CLICKED(IDC_BUTTON_VERSION, OnButtonVersion)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_TCP, OnButtonCloseTcp)
	ON_BN_CLICKED(IDC_BUTTON_READ, OnButtonRead)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_CERT0, &CEzManagerLib_ExampleDlg::OnBnClickedButtonCert0)
	ON_BN_CLICKED(IDC_BUTTON_CERT1, &CEzManagerLib_ExampleDlg::OnBnClickedButtonCert1)
	ON_BN_CLICKED(IDC_BUTTON_CERT2, &CEzManagerLib_ExampleDlg::OnBnClickedButtonCert2)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEzManagerLib_ExampleDlg message handlers

BOOL CEzManagerLib_ExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	this->m_eztcp_addr = "10.1.0.1";
	GetDlgItem(IDC_EZTCP_ADDR)->EnableWindow(FALSE);

	this->GetDlgItem(IDC_BUTTON_CERT0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BUTTON_CERT1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BUTTON_CERT2)->EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEzManagerLib_ExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEzManagerLib_ExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEzManagerLib_ExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEzManagerLib_ExampleDlg::OnButtonSearch() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	int nCnt, nErr, res, i = 0;
	CString str;

	res = EzTCP_Search(0, &nErr);

	nCnt = get_eztcp_count();

	if ( nCnt > 0 )
	{
		this->m_list_eztcp.ResetContent();

		for ( i = 0 ; i < nCnt ; i++ )
		{
			struct eztcp_info out_eztcp_info;
			memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

			if ( get_eztcp_info_by_index(i, &out_eztcp_info) == EZTCP_SUCCESS )
			{
				str.Format("%02x:%02x:%02x:%02x:%02x:%02x [%s] - %s",
					out_eztcp_info.mac_address[0],
					out_eztcp_info.mac_address[1],
					out_eztcp_info.mac_address[2],
					out_eztcp_info.mac_address[3],
					out_eztcp_info.mac_address[4],
					out_eztcp_info.mac_address[5],
					out_eztcp_info.product_name,
					out_eztcp_info.hostname);

				m_list_eztcp.InsertString(i, str);
			}
		}
		h_scroll();
	}
	else
	{
		str.Format("There's no ezTCP.");

		if ( res == EZTCP_ERR )
			str.AppendFormat(" [Error:%d]", nErr);
		this->m_list_eztcp.ResetContent();
		AfxMessageBox(str);
	}
}

void CEzManagerLib_ExampleDlg::OnRadioLocal() 
{
	// TODO: Add your control notification handler code here
	//this->m_remote_ip.EnableWindow(FALSE);
	this->GetDlgItem(IDC_EZTCP_ADDR)->EnableWindow(FALSE);

	GetDlgItem(IDC_EDIT_EA0)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA3)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA4)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDIT_EA5)->EnableWindow(TRUE);
}

void CEzManagerLib_ExampleDlg::OnRadioRemote() 
{
	// TODO: Add your control notification handler code here
	//this->m_remote_ip.EnableWindow(TRUE);
	this->GetDlgItem(IDC_EZTCP_ADDR)->EnableWindow(TRUE);

	GetDlgItem(IDC_EDIT_EA0)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA3)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA4)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_EA5)->EnableWindow(FALSE);
}

void CEzManagerLib_ExampleDlg::OnSelchangeListEztcp() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();

	if ( idx >= 0 )
	{
		//struct lib_env *lib_env = &this->lib_env_base[idx];
		struct eztcp_info out_eztcp_info;
		memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

		if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
		{
			int is_cert = ::is_certificates(out_eztcp_info.mac_address);
			TRACE("CERTIFICATES %d\r\n", is_cert);

			if(is_cert == 1)
			{
				this->GetDlgItem(IDC_BUTTON_CERT0)->EnableWindow(TRUE);
				this->GetDlgItem(IDC_BUTTON_CERT1)->EnableWindow(TRUE);
				this->GetDlgItem(IDC_BUTTON_CERT2)->EnableWindow(TRUE);
			}
			else
			{
				this->GetDlgItem(IDC_BUTTON_CERT0)->EnableWindow(FALSE);
				this->GetDlgItem(IDC_BUTTON_CERT1)->EnableWindow(FALSE);
				this->GetDlgItem(IDC_BUTTON_CERT2)->EnableWindow(FALSE);
			}

			char buf[128]; 

			this->m_eztcp_addr.Format("%s", out_eztcp_info.hostname);

			this->m_ea0.Format("%02x", out_eztcp_info.mac_address[0]);
			this->m_ea1.Format("%02x", out_eztcp_info.mac_address[1]);
			this->m_ea2.Format("%02x", out_eztcp_info.mac_address[2]);
			this->m_ea3.Format("%02x", out_eztcp_info.mac_address[3]);
			this->m_ea4.Format("%02x", out_eztcp_info.mac_address[4]);
			this->m_ea5.Format("%02x", out_eztcp_info.mac_address[5]);

			//--------------------------------------------------------------------
			// pwd

			//--------------------------------------------------------------------

			//--------------------------------------------------------------------
			// Product information
			//
			this->m_product.Format("%s", out_eztcp_info.product_name);

			memset(buf, 0x00, 128);
			get_version(out_eztcp_info.mac_address, buf);
			this->m_fw_version.Format("%s", buf);
			//--------------------------------------------------------------------


			//-----------------------------------------------------------------
			// Network information
			//
			memset(buf, 0x00, 128);
			get_ip4_local_address(out_eztcp_info.mac_address, buf);
			m_local_ip_addr.Format("%s", buf);

			memset(buf, 0x00, 128);
			get_ip4_subnet_mask(out_eztcp_info.mac_address, buf);
			m_subnet_ip4.Format("%s", buf);			

			// IP Change Trap
			this->m_combo_ddns_ctrl.SetCurSel(get_ip4_change_notification_type(out_eztcp_info.mac_address));

			memset(buf, 0x00, 128);
			get_ip4_change_notification_ddns_id(out_eztcp_info.mac_address, buf);
			this->m_ddns_id.Format("%s",	buf);

			memset(buf, 0x00, 128);
			get_ip4_change_notification_ddns_pwd(out_eztcp_info.mac_address, buf);
			this->m_ddns_pwd.Format("%s",	buf);

			memset(buf, 0x00, 128);
			get_ip4_change_notification_peer_address(out_eztcp_info.mac_address, buf);
			this->m_ddns_hostname.Format("%s", buf);

			this->m_combo_style_ctrl.SetCurSel(get_ip4_change_notification_data_type(out_eztcp_info.mac_address));

			memset(buf, 0x00, 128);
			get_ip4_change_notification_peer_port(out_eztcp_info.mac_address, buf);
			this->m_ddns_port_str.Format("%s", buf);

			memset(buf, 0x00, 128);
			get_ip4_change_notification_interval(out_eztcp_info.mac_address, buf);
			this->m_ddns_interval_str.Format("%s", buf);

			memset(buf, 0x00, 128);
			get_ip4_change_notification_peer_address(out_eztcp_info.mac_address, buf);
			this->m_ddns_hostname.Format("%s", buf);
			//-----------------------------------------------------------------


			//------------------------------------------------------------------------------------
			// UART
			//
			//struct uart_env		*p_uart_env		= lib_env->uart_env;
			//struct pseudo_uart_var_env	*p_uart_var_env = lib_env->pseudo_uart_var_env;

			int uart_count = get_uart_count(out_eztcp_info.mac_address);

			for ( int port = 0 ; port < 4 ; port++ )
			{

				if ( port < uart_count )
				{
					p_baud_ctrl[port]->EnableWindow(TRUE);
					p_mux_ctrl[port]->EnableWindow(TRUE);
					p_peer_ctrl[port]->EnableWindow(TRUE);

					p_baud[port]->Format("%d", get_uart_baudrate(out_eztcp_info.mac_address, port));
					p_mux_ctrl[port]->SetCurSel(get_uart_communication_mode(out_eztcp_info.mac_address, port));

					*p_peer[port] = _T("");
					memset(buf, 0x00, 128);
					get_uart_peer_address(out_eztcp_info.mac_address, port, buf);
					p_peer[port]->Format("%s", buf);
				}
				else
				{
					p_baud_ctrl[port]->EnableWindow(FALSE);
					p_mux_ctrl[port]->EnableWindow(FALSE);
					p_peer_ctrl[port]->EnableWindow(FALSE);
				}
			}
			//------------------------------------------------------------------------------------

			//------------------------------------------------------------------------------------
			// I/O information.
			//
			if ( is_io(out_eztcp_info.mac_address) == 1 )
			{
				//struct io_env	*p_io_env	= &lib_env_base[idx].io_env;
				//struct opt_env	*p_opt_env	= &lib_env_base[idx].opt_env;

				//if ( p_io_env->use_flag == 1 )
				{
					this->m_http	= get_io_http(out_eztcp_info.mac_address);
					this->m_modbus	= get_io_modbus(out_eztcp_info.mac_address);
					this->m_macro	= get_io_macro(out_eztcp_info.mac_address);

					memset(buf, 0x00, 128);	get_io_unit_id(out_eztcp_info.mac_address, buf);
					this->m_unit_id.Format("%s", buf);


					memset(buf, 0x00, 128);	get_io_input_address(out_eztcp_info.mac_address, buf);
					this->m_input_address.Format("%s", buf);

					memset(buf, 0x00, 128);	get_io_output_address(out_eztcp_info.mac_address, buf);
					this->m_output_address.Format("%s", buf);

					int output_number	= get_io_output_number(out_eztcp_info.mac_address);
					int input_number	= get_io_input_number(out_eztcp_info.mac_address);

					// macro
					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 0, buf);
					this->m_script_0.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 1, buf);
					this->m_script_1.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 2, buf);
					this->m_script_2.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 3, buf);
					this->m_script_3.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 4, buf);
					this->m_script_4.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 5, buf);
					this->m_script_5.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 6, buf);
					this->m_script_6.Format("%s", buf);

					memset(buf, 0, 128);	get_io_macro_text(out_eztcp_info.mac_address, 7, buf);
					this->m_script_7.Format("%s", buf);

					// input comment
					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 0, buf);
					this->m_di_str0.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 1, buf);
					this->m_di_str1.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 2, buf);
					this->m_di_str2.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 3, buf);
					this->m_di_str3.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 4, buf);
					this->m_di_str4.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 5, buf);
					this->m_di_str5.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 6, buf);
					this->m_di_str6.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 0, 7, buf);
					this->m_di_str7.Format("%s", buf);

					// output comment
					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 0, buf);
					this->m_do_str0.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 1, buf);
					this->m_do_str1.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 2, buf);
					this->m_do_str2.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 3, buf);
					this->m_do_str3.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 4, buf);
					this->m_do_str4.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 5, buf);
					this->m_do_str5.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 6, buf);
					this->m_do_str6.Format("%s", buf);

					memset(buf, 0, 128);	get_io_comment(out_eztcp_info.mac_address, 1, 7, buf);
					this->m_do_str7.Format("%s", buf);

					m_script_0_ctrl.EnableWindow(TRUE);
					m_script_1_ctrl.EnableWindow(TRUE);
					m_script_2_ctrl.EnableWindow(TRUE);
					m_script_3_ctrl.EnableWindow(TRUE);
					m_script_4_ctrl.EnableWindow(TRUE);
					m_script_5_ctrl.EnableWindow(TRUE);
					m_script_6_ctrl.EnableWindow(TRUE);
					m_script_7_ctrl.EnableWindow(TRUE);

					m_slave_id_ctrl.EnableWindow(TRUE);
					m_output_addr_ctrl.EnableWindow(TRUE);
					m_input_addr_ctrl.EnableWindow(TRUE);

					m_modbus_ctrl.EnableWindow(TRUE);
					m_macro_ctrl.EnableWindow(TRUE);
					m_http_ctrl.EnableWindow(TRUE);

					m_di_str0_ctrl.EnableWindow(TRUE);
					m_di_str1_ctrl.EnableWindow(TRUE);
					m_di_str2_ctrl.EnableWindow(TRUE);
					m_di_str3_ctrl.EnableWindow(TRUE);
					m_di_str4_ctrl.EnableWindow(TRUE);
					m_di_str5_ctrl.EnableWindow(TRUE);
					m_di_str6_ctrl.EnableWindow(TRUE);
					m_di_str7_ctrl.EnableWindow(TRUE);

					m_do_str0_ctrl.EnableWindow(TRUE);
					m_do_str1_ctrl.EnableWindow(TRUE);
					m_do_str2_ctrl.EnableWindow(TRUE);
					m_do_str3_ctrl.EnableWindow(TRUE);
					m_do_str4_ctrl.EnableWindow(TRUE);
					m_do_str5_ctrl.EnableWindow(TRUE);
					m_do_str6_ctrl.EnableWindow(TRUE);
					m_do_str7_ctrl.EnableWindow(TRUE);
				}
			}
			else
			{
				m_script_0_ctrl.EnableWindow(FALSE);
				m_script_1_ctrl.EnableWindow(FALSE);
				m_script_2_ctrl.EnableWindow(FALSE);
				m_script_3_ctrl.EnableWindow(FALSE);
				m_script_4_ctrl.EnableWindow(FALSE);
				m_script_5_ctrl.EnableWindow(FALSE);
				m_script_6_ctrl.EnableWindow(FALSE);
				m_script_7_ctrl.EnableWindow(FALSE);

				m_slave_id_ctrl.EnableWindow(FALSE);
				m_output_addr_ctrl.EnableWindow(FALSE);
				m_input_addr_ctrl.EnableWindow(FALSE);

				m_modbus_ctrl.EnableWindow(FALSE);
				m_macro_ctrl.EnableWindow(FALSE);
				m_http_ctrl.EnableWindow(FALSE);

				m_di_str0_ctrl.EnableWindow(FALSE);
				m_di_str1_ctrl.EnableWindow(FALSE);
				m_di_str2_ctrl.EnableWindow(FALSE);
				m_di_str3_ctrl.EnableWindow(FALSE);
				m_di_str4_ctrl.EnableWindow(FALSE);
				m_di_str5_ctrl.EnableWindow(FALSE);
				m_di_str6_ctrl.EnableWindow(FALSE);
				m_di_str7_ctrl.EnableWindow(FALSE);

				m_do_str0_ctrl.EnableWindow(FALSE);
				m_do_str1_ctrl.EnableWindow(FALSE);
				m_do_str2_ctrl.EnableWindow(FALSE);
				m_do_str3_ctrl.EnableWindow(FALSE);
				m_do_str4_ctrl.EnableWindow(FALSE);
				m_do_str5_ctrl.EnableWindow(FALSE);
				m_do_str6_ctrl.EnableWindow(FALSE);
				m_do_str7_ctrl.EnableWindow(FALSE);
			}
			//------------------------------------------------------------------------------------
		}

		UpdateData(FALSE);
	}
}

static char* tcp_state[] =
{
	"CLOSED", "LISTEN", "SYN_SENT", "SYN_RCVD", "ESTABLISHED", "FIN_WAIT1",
	"FIN_WAIT2", "CLOSE_WAIT", "CLOSING", "LAST_ACK", "TIME_WAIT", "END"
};

void CEzManagerLib_ExampleDlg::OnButtonStatus() 
{
	// TODO: Add your control notification handler code here

	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	//struct lib_env* lib_env = &this->lib_env_base[idx];


	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{
		m_status = _T("");

		res = EzTCP_Status(out_eztcp_info.mac_address, 0, &nErr);

		if ( res == EZTCP_SUCCESS )
		{
			this->m_tcp_connection.ResetContent();

			int session_count = get_tcpip4_session_count();

			if ( session_count > 0 )
			{
				for ( int i = 0 ; i < session_count ; i++ )
				{
					char session_info[1024];
					memset(session_info, 0x00, 1024);

					if ( get_tcpip4_session_info(i, session_info) == 1 )
					{
						CString str;
						str.Format("%s", session_info);
						int idx = this->m_tcp_connection.AddString(str);
						this->m_tcp_connection.SetItemData(idx, i);
					}
				}
			}

			int session_count6 = get_tcpip6_session_count();

			if ( session_count6 > 0 )
			{
				for ( int i = 0 ; i < session_count6 ; i++ )
				{
					char session_info[1024];
					memset(session_info, 0x00, 1024);


					if ( get_tcpip6_session_info(i, session_info) == 1 )
					{
						CString str;
						str.Format("%s", session_info);
						int idx = this->m_tcp_connection.AddString(str);
						this->m_tcp_connection.SetItemData(idx, i | 0x80);
					}
				}	
			}


			this->m_tcp_connection.SetCurSel(0);

			int status_len = get_status_string_length();

			get_status_string(m_status.GetBuffer(status_len));
			m_status.ReleaseBuffer();
		}
		else
		{
			CString err_msg;
			err_msg.Format("[%d] EzTCP_Status fail.", nErr);
			AfxMessageBox(err_msg);
		}
	}

	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonWrite() 
{
	// TODO: Add your control notification handler code here
	int		idx = this->m_list_eztcp.GetCurSel();
	int		res;
	char	pwd_buf[PASSWD_SIZE];
	CString err_msg;

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	if ( !UpdateData(TRUE) ) return;

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{

		//-----------------------------------------------------------------
		// Network information
		//
		if ( (res = set_ip4_local_address(out_eztcp_info.mac_address, this->m_local_ip_addr.GetBuffer(this->m_local_ip_addr.GetLength())) ) != EZTCP_SUCCESS )
		{
			err_msg.Format("set_local_ip4 error. [%d]", res);
			AfxMessageBox(err_msg);
			return;
		}

		if ( (res = set_ip4_subnet_mask(out_eztcp_info.mac_address, this->m_subnet_ip4.GetBuffer(this->m_subnet_ip4.GetLength())) ) != EZTCP_SUCCESS )
		{
			err_msg.Format("set_subnet_ip4 error. [%d]", res);
			AfxMessageBox(err_msg);
			return;
		}

		// IP Change Trap
		int ip4_change_type = this->m_combo_ddns_ctrl.GetCurSel();
		if ( (res = set_ip4_change_notification_type(out_eztcp_info.mac_address, ip4_change_type)) != EZTCP_SUCCESS )
		{
			err_msg.Format("set_ip_notification_type error. [%d]", res);
			AfxMessageBox(err_msg);
			return;
		}

		if ( ip4_change_type == 1 )
		{
			if ( !this->m_ddns_id.IsEmpty() )
			{			
				if ( (res = set_ip4_change_notification_ddns_id(out_eztcp_info.mac_address, m_ddns_id.GetBuffer(m_ddns_id.GetLength()))) != EZTCP_SUCCESS )
				{
					err_msg.Format("set_ip_notification_ddns_id error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}
			}
			if ( !this->m_ddns_pwd.IsEmpty() )
			{
				if ( (res = set_ip4_change_notification_ddns_pwd(out_eztcp_info.mac_address, m_ddns_pwd.GetBuffer(m_ddns_pwd.GetLength()))) != EZTCP_SUCCESS )			
				{
					err_msg.Format("set_ip_notification_ddns_pwd error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}
			}

			if ( (res = set_ip4_change_notification_peer_address(out_eztcp_info.mac_address, m_ddns_hostname.GetBuffer(m_ddns_hostname.GetLength()))) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_ip_notification_peer_address error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}
		}
		else if ( ip4_change_type == 2 || ip4_change_type == 3 )
		{
			int data_i = (int)strtol(this->m_ddns_interval_str, 0, 10);
			if ( (res = set_ip4_change_notification_interval(out_eztcp_info.mac_address, data_i)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_ip_notification_interval error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			data_i = (int)strtol(this->m_ddns_port_str, 0, 10);
			if ( (res = set_ip4_change_notification_peer_port(out_eztcp_info.mac_address, data_i)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_ip_notification_port error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			if ( (res = set_ip4_change_notification_data_type(out_eztcp_info.mac_address, this->m_combo_style_ctrl.GetCurSel())) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_ip_notification_data_type error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			if ( (res = set_ip4_change_notification_peer_address(out_eztcp_info.mac_address, m_ddns_hostname.GetBuffer(m_ddns_hostname.GetLength()))) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_ip_notification_host error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}
		}




		//-----------------------------------------------------------------

		//------------------------------------------------------------------------------------
		// UART
		//
		//struct uart_env		*p_uart_env		= lib_env.uart_env;

		int uart_count = get_uart_count(out_eztcp_info.mac_address);

		for ( int port = 0 ; port < 4 ; port++ )
		{
			if ( port < uart_count )
			{
				CString b_temp = *p_baud[port];
				CString a_temp = *p_peer[port];

				int data_i = strtol(b_temp, 0, 10);
				if ( (res = set_uart_baudrate(out_eztcp_info.mac_address, port, data_i)) != EZTCP_SUCCESS )
				{
					err_msg.Format("set_uart_baudrate error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}

				if ( (res = set_uart_communication_mode(out_eztcp_info.mac_address, port, p_mux_ctrl[port]->GetCurSel())) != EZTCP_SUCCESS )
				{
					err_msg.Format("set_uart_communication_mode error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}

				if ( (res = set_uart_peer_address(out_eztcp_info.mac_address, port, a_temp.GetBuffer(a_temp.GetLength()))) != EZTCP_SUCCESS )
				{
					err_msg.Format("set_uart_peer_address error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}
			}
		}
		//------------------------------------------------------------------------------------

		//------------------------------------------------------------------------------------
		// I/O information.
		//

		if ( is_io(out_eztcp_info.mac_address) == 1 )
		{			
			if ( (res = set_io_http(out_eztcp_info.mac_address, this->m_http)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_io_http error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			if ( (res = set_io_modbus(out_eztcp_info.mac_address, this->m_modbus)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_io_modbus error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			if ( get_io_macro_type(out_eztcp_info.mac_address) == 0 )
			{
				if ( (res = set_io_macro(out_eztcp_info.mac_address, this->m_macro)) != EZTCP_SUCCESS )
				{
					err_msg.Format("set_io_macro error. [%d]", res);
					AfxMessageBox(err_msg);
					return;
				}
			}

			int data_i = (int)strtol(this->m_unit_id, 0, 10);
			if ( (res = set_io_unit_id(out_eztcp_info.mac_address, data_i)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_io_unit_id error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			data_i = (int)strtol(this->m_input_address, 0, 10);
			if ( (res = set_io_input_address(out_eztcp_info.mac_address, data_i)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_io_input_address error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}

			data_i = (int)strtol(this->m_output_address, 0, 10);
			if ( (res = set_io_output_address(out_eztcp_info.mac_address, data_i)) != EZTCP_SUCCESS )
			{
				err_msg.Format("set_io_output_address error. [%d]", res);
				AfxMessageBox(err_msg);
				return;
			}


			int output_number = get_io_output_number(out_eztcp_info.mac_address);
			int input_number = get_io_input_number(out_eztcp_info.mac_address);

			for ( int idx = 0 ; idx < output_number ; idx++ )
			{
				switch(idx)
				{
				case 0:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 0, this->m_script_0.GetBuffer(m_script_0.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 0, this->m_do_str0.GetBuffer(m_do_str0.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 1:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 1, this->m_script_1.GetBuffer(m_script_1.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 1, this->m_do_str1.GetBuffer(m_do_str1.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 2:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 2, this->m_script_2.GetBuffer(m_script_2.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 2, this->m_do_str2.GetBuffer(m_do_str2.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 3:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 3, this->m_script_3.GetBuffer(m_script_3.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 3, this->m_do_str3.GetBuffer(m_do_str3.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 4:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 4, this->m_script_4.GetBuffer(m_script_4.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 4, this->m_do_str4.GetBuffer(m_do_str4.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 5:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 5, this->m_script_5.GetBuffer(m_script_5.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 5, this->m_do_str5.GetBuffer(m_do_str5.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 6:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 6, this->m_script_6.GetBuffer(m_script_6.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 6, this->m_do_str6.GetBuffer(m_do_str6.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 7:
					if ( (res = set_io_macro_text(out_eztcp_info.mac_address, 7, this->m_script_7.GetBuffer(m_script_7.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_macro_text error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}

					if ( (res = set_io_comment(out_eztcp_info.mac_address, 1, 7, this->m_do_str7.GetBuffer(m_do_str7.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				}
			}

			for ( int idx = 0 ; idx < input_number ; idx++ )
			{
				switch(idx)
				{
				case 0:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 0, this->m_di_str0.GetBuffer(m_di_str0.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 1:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 1, this->m_di_str1.GetBuffer(m_di_str1.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 2:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 2, this->m_di_str2.GetBuffer(m_di_str2.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 3:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 3, this->m_di_str3.GetBuffer(m_di_str3.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 4:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 4, this->m_di_str4.GetBuffer(m_di_str4.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 5:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 5, this->m_di_str5.GetBuffer(m_di_str5.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 6:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 6, this->m_di_str6.GetBuffer(m_di_str6.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				case 7:
					if ( (res = set_io_comment(out_eztcp_info.mac_address, 0, 7, this->m_di_str7.GetBuffer(m_di_str7.GetLength()))) != EZTCP_SUCCESS )
					{
						err_msg.Format("set_io_comment error. [%d]", res);
						AfxMessageBox(err_msg);
						return;
					}
					break;
				}
			}

		}
		//-------------------------------------------------------------------

		//-------------------------------------------------------------------
		// password
		memset(pwd_buf, 0x00, PASSWD_SIZE);

		if ( this->m_cur_pwd.GetLength() != 0 )
		{
			memcpy(pwd_buf, this->m_cur_pwd, this->m_cur_pwd.GetLength());
		}

		int nErr = 0;
		res = EzTCP_Write(out_eztcp_info.mac_address, pwd_buf, 0, &nErr);

		if ( res == EZTCP_SUCCESS )
		{
			AfxMessageBox("Write success...");
		}
		else
		{
			this->print_error_message(nErr);
		}
	}	

	//-------------------------------------------------------------------
}

void CEzManagerLib_ExampleDlg::OnButtonChangePwd() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	char cur_pwd[PASSWD_SIZE];
	char new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	UpdateData(TRUE);

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{
		//-------------------------------------------------------------------
		// password
		if ( this->m_cur_pwd.GetLength() == 0 )
		{
			AfxMessageBox("Enter the password.");
			return;
		}

		if ( this->m_new_pwd.GetLength() == 0 )
		{
			AfxMessageBox("Enter the password.");
			return;
		}

		if ( this->m_cur_pwd.GetLength() > 8 )
		{
			AfxMessageBox("Maximum password length is 8.");
			return;
		}

		if ( this->m_new_pwd.GetLength() > 8 )
		{
			AfxMessageBox("Maximum password length is 8.");
			return;
		}

		memset(cur_pwd, 0x00, PASSWD_SIZE);
		memcpy(cur_pwd, this->m_cur_pwd, this->m_cur_pwd.GetLength());

		memset(new_pwd, 0x00, PASSWD_SIZE);
		memcpy(new_pwd, this->m_new_pwd, this->m_new_pwd.GetLength());
		//-------------------------------------------------------------------

		nErr = 0;
		res = EzTCP_ChangePassword(out_eztcp_info.mac_address, cur_pwd, new_pwd, 0, &nErr);

		if ( res == EZTCP_SUCCESS )
		{
			AfxMessageBox("Password write success...");			
		}
		else
		{
			this->print_error_message(nErr);
		}

		this->m_cur_pwd = _T("");
		this->m_new_pwd = _T("");
	}
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonDeletePwd() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	char cur_pwd[PASSWD_SIZE];
	char new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	UpdateData(TRUE);

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{
		//-------------------------------------------------------------------
		// password
		memset(cur_pwd, 0x00, PASSWD_SIZE);
		if ( this->m_cur_pwd.GetLength() > 0 )
			memcpy(cur_pwd, this->m_cur_pwd, this->m_cur_pwd.GetLength());

		memset(new_pwd, 0x00, PASSWD_SIZE);	
		//-------------------------------------------------------------------

		nErr = 0;
		res = EzTCP_ChangePassword(out_eztcp_info.mac_address, cur_pwd, NULL, 0, &nErr);

		if ( res == EZTCP_SUCCESS )
		{
			AfxMessageBox("Password write success...");			
		}
		else
		{
			this->print_error_message(nErr);
		}

		this->m_cur_pwd = _T("");
		this->m_new_pwd = _T("");
	}
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonPwdSet() 
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();
	int res, nErr;
	char new_pwd[PASSWD_SIZE];

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	UpdateData(TRUE);

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{
		//-------------------------------------------------------------------
		// password
		if ( this->m_new_pwd.GetLength() == 0 )
		{
			AfxMessageBox("Enter the password.");
			return;
		}

		if ( this->m_new_pwd.GetLength() > 8 )
		{
			AfxMessageBox("Maximum password length is 8.");
			return;
		}
		memset(new_pwd, 0x00, PASSWD_SIZE);
		memcpy(new_pwd, this->m_new_pwd, this->m_new_pwd.GetLength());
		//-------------------------------------------------------------------

		nErr = 0;
		res = EzTCP_ChangePassword(out_eztcp_info.mac_address, NULL, new_pwd, 0, &nErr);

		if ( res == EZTCP_SUCCESS )
		{
			AfxMessageBox("Password write success...");
		}
		else
		{
			this->print_error_message(nErr);
		}

		this->m_cur_pwd = _T("");
		this->m_new_pwd = _T("");
	}
	UpdateData(FALSE);
}

void CEzManagerLib_ExampleDlg::OnButtonVersion() 
{
	// TODO: Add your control notification handler code here

	char buf[256]; memset(buf, 0x00, 256);

	GetLibraryVersion(buf);

	AfxMessageBox(buf);
}

void CEzManagerLib_ExampleDlg::OnButtonCloseTcp() 
{
	// TODO: Add your control notification handler code here
	char pwd_buf[PASSWD_SIZE];
	int res, nErr;

	int session_number	= this->m_tcp_connection.GetCurSel();
	int session_type	= this->m_tcp_connection.GetItemData(session_number);
	int idx				= this->m_list_eztcp.GetCurSel();

	if ( session_number < 0 ) return;

	if ( idx < 0 ) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	if ( !UpdateData(TRUE) ) return;

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if ( get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS )
	{
		//-------------------------------------------------------------------
		// password
		memset(pwd_buf, 0x00, PASSWD_SIZE);

		if ( this->m_cur_pwd.GetLength() != 0 )
		{
			memcpy(pwd_buf, this->m_cur_pwd, this->m_cur_pwd.GetLength());
		}
		//-------------------------------------------------------------------

		nErr = 0;

		if ( (session_type  & 0x80) == 0x80 )
		{
			session_number = session_type & 0x7f;

			res = EzTCP_CloseTcpIp6(out_eztcp_info.mac_address, session_number, pwd_buf, &nErr);
		}
		else
		{
			session_number = session_type;

			res = EzTCP_CloseTcpIp4(out_eztcp_info.mac_address, session_number, pwd_buf, &nErr);
		}


		if ( res == EZTCP_SUCCESS )
		{
			AfxMessageBox("success...");
		}
		else
		{
			this->print_error_message(nErr);
		}
	}
}


void CEzManagerLib_ExampleDlg::OnBnClickedButtonCert0()
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();

	if(idx < 0) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if(get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS)
	{
		int err = 0;
		int res = EzTCP_ReadCert(out_eztcp_info.mac_address, out_eztcp_info.search_port, &err );
		if(res == EZTCP_SUCCESS)
		{
			int cert_len = get_certificates_string_length();

			CString cert;
			get_certificates_string(cert.GetBuffer(cert_len));
			cert.ReleaseBuffer();

			AfxMessageBox(cert);
		}
		else
		{
			this->print_error_message(err);
		}
	}
}

#include "SelfSignedCertDlg.h"

void CEzManagerLib_ExampleDlg::OnBnClickedButtonCert1()
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();

	if(idx < 0) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if(get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS)
	{
		CSelfSignedCertDlg dlg;
		if ( dlg.DoModal() == IDOK )
		{
			int err = 0;
			int res = EzTCP_WriteSelfSignedCertificates(
				out_eztcp_info.mac_address,
				// key length
				dlg.m_opt_0,
				// Country Name
				dlg.m_opt_1.GetBuffer(),
				// State of province
				dlg.m_opt_2.GetBuffer(),
				// localityName
				dlg.m_opt_3.GetBuffer(),
				// Organization Name
				dlg.m_opt_4.GetBuffer(),
				// Organization Unit Name
				dlg.m_opt_5.GetBuffer(),
				// Common Name
				dlg.m_opt_6.GetBuffer(),
				// Email
				dlg.m_opt_7.GetBuffer(),
				out_eztcp_info.search_port, 
				&err
				);

			if(res == EZTCP_SUCCESS)
			{
				AfxMessageBox("Write success...");
			}
			else
			{
				this->print_error_message(err);
			}
		}
	}
}

#include "Cert2.h"

void CEzManagerLib_ExampleDlg::OnBnClickedButtonCert2()
{
	// TODO: Add your control notification handler code here
	int idx = this->m_list_eztcp.GetCurSel();

	if(idx < 0) 
	{
		AfxMessageBox("Select ezTCP before execute this function.");
		return;
	}

	struct eztcp_info out_eztcp_info;
	memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

	if(get_eztcp_info_by_index(idx, &out_eztcp_info) == EZTCP_SUCCESS)
	{
		CCert2 dlg;
		if(dlg.DoModal() == IDOK)
		{
			char *certificates_filepath = dlg.m_certificates.GetBuffer();
			char *certificates_password = dlg.m_certificates_password.IsEmpty() ? NULL : dlg.m_certificates_password.GetBuffer();
			char *rsa_key_filepath = dlg.m_key.IsEmpty() ? NULL : dlg.m_key.GetBuffer();
			char *rsa_key_password = dlg.m_key_password.IsEmpty() ? NULL : dlg.m_key_password.GetBuffer();

			int err = 0;
			int res = EzTCP_WriteCertificates(
				out_eztcp_info.mac_address, 
				certificates_filepath, 
				certificates_password, 
				rsa_key_filepath, 
				rsa_key_password, 
				out_eztcp_info.search_port, 
				&err);

			if(res == EZTCP_SUCCESS)
			{
				AfxMessageBox("Write success...");
			}
			else
			{
				this->print_error_message(err);
			}
		}
	}

}


void CEzManagerLib_ExampleDlg::OnButtonRead() 
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData(TRUE) ) return;

	//int idx = this->m_list_eztcp.GetCurSel();
	int res = 0, nErr = 0;

	unsigned char mac_addr[6];

	mac_addr[0] = (unsigned char)strtol(this->m_ea0, 0 , 16);
	mac_addr[1] = (unsigned char)strtol(this->m_ea1, 0 , 16);
	mac_addr[2] = (unsigned char)strtol(this->m_ea2, 0 , 16);
	mac_addr[3] = (unsigned char)strtol(this->m_ea3, 0 , 16);
	mac_addr[4] = (unsigned char)strtol(this->m_ea4, 0 , 16);
	mac_addr[5] = (unsigned char)strtol(this->m_ea5, 0 , 16);

	char *ip_ptr = this->m_eztcp_addr.GetBuffer(this->m_eztcp_addr.GetLength());

	res = EzTCP_Read(this->m_local_remote, mac_addr, ip_ptr, 0, &nErr);

	if ( res == EZTCP_SUCCESS ) // read success
	{
		this->m_list_eztcp.ResetContent();

		int nCnt = get_eztcp_count();
		CString str;

		for ( int i = 0 ; i < nCnt ; i++ )
		{
			struct eztcp_info out_eztcp_info;
			memset(&out_eztcp_info, 0x00, sizeof(struct eztcp_info));

			if ( get_eztcp_info_by_index(i, &out_eztcp_info) == EZTCP_SUCCESS )
			{
				str.Format("%02x:%02x:%02x:%02x:%02x:%02x [%s] - %s",
					out_eztcp_info.mac_address[0],
					out_eztcp_info.mac_address[1],
					out_eztcp_info.mac_address[2],
					out_eztcp_info.mac_address[3],
					out_eztcp_info.mac_address[4],
					out_eztcp_info.mac_address[5],
					out_eztcp_info.product_name,
					out_eztcp_info.hostname);

				m_list_eztcp.InsertString(i, str);
			}
		}

		h_scroll();
	}
	else // read fail
	{
		this->print_error_message(nErr);
	}
}

void CEzManagerLib_ExampleDlg::print_error_message(int code)
{
	CString msg;
	LPSTR	lpMsgBuf;

	switch(code)
	{
	case EZTCP_ERR_PWD:
		AfxMessageBox("Password mismatch error occured.");
		break;
	case EZTCP_ERR_RES:
		AfxMessageBox("No response from selected ezTCP.");
		break;
	case EZTCP_ERR_LOCAL_IP:
		AfxMessageBox("Local IP Address Error");
		break;
	case EZTCP_ERR_IO_SCRIPT:
		AfxMessageBox("Macro Syntax Error");
		break;
	case EZTCP_ERR_IO_ADDR:
		AfxMessageBox("I/O Port Address Error");
		break;
	case EZTCP_ERR_LOCAL_PORT_0:
		AfxMessageBox("Local Port Number Error");
		break;
	case EZTCP_ERR_LOCAL_PORT_1:
		AfxMessageBox("Port Number 23 is not available");
		break;
	case EZTCP_ERR_LOCAL_PORT_2:
		AfxMessageBox("Local and Modbus/TCP Port numbers are duplicated.");
		break;
	case EZTCP_ERR_LOCAL_PORT_3:
		AfxMessageBox("The port number 80 is not available for Local Port.");
		break;
	case EZTCP_ERR_LOCAL_PORT_4:
		AfxMessageBox("The port number 50005 is not available for Local Port.");
		break;
	case EZTCP_ERR_LOCAL_PORT_5:
		AfxMessageBox("The port number 50006 is not available for Local Port.");
		break;
	case EZTCP_ERR_LOCAL_PORT_6:
		AfxMessageBox("The port number 50007 is not available for Local Port.");
		break;
	case EZTCP_ERR_PRODUCT_MISMATCH:
		AfxMessageBox("Product ID Mismatch");
		break;
	case EZTCP_ERR_UNKNOWN:
		AfxMessageBox("Unknown Error");
		break;
	case EZTCP_ERR_NO_INFO:
		AfxMessageBox("There is no available information to write.");
		break;
	default:
		//msg.Format("Invalid Error Code [%d]", code);
		if(code < 0)
		{
			msg.Format(_T("ERROR CODE: %d"), code);
			AfxMessageBox(msg);
		}
		else
		{
			FormatMessage(
				FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL,
				code,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				(LPSTR)&lpMsgBuf, 
				0, 
				NULL);
			msg.Format("[%d] %s", code, lpMsgBuf);
			msg.Replace("\r\n", "");
			LocalFree(lpMsgBuf);
			AfxMessageBox(msg);
		}
		break;
	}
}

void CEzManagerLib_ExampleDlg::h_scroll()
{
	CString str;
	CSize	sz;
	int dx = 0;
	CDC* pDC = this->m_list_eztcp.GetDC();

	for ( int i = 0 ; i < this->m_list_eztcp.GetCount() ; i++ )
	{
		this->m_list_eztcp.GetText(i, str);
		sz = pDC->GetTextExtent(str);
		if ( sz.cx > dx)
			dx = sz.cx;
	}
	this->m_list_eztcp.ReleaseDC(pDC);
	this->m_list_eztcp.SetHorizontalExtent(dx + 100);
}



